import java.io.*;

/**
 * uToCoLbY`Lost in blue 2`ṽZ[uf[^̃`FbNTC
 */
class Lostinblue2Adjuster{

	public static void main(String args[]){
		//`FbN
		if(args.length != 1){
			System.err.println("Usage: java Lostinblue2Adjuster filename");
			System.exit(1);
		}

		//gq`FbN
		int foot = 0;
		if(args[0].toLowerCase().endsWith(".duc") || args[0].toLowerCase().endsWith(".dss")){
			foot = 500;
		}
		else if(args[0].toLowerCase().endsWith(".dst")){
			System.out.println("Not processed");
			System.exit(1);
		}

		RandomAccessFile raf = null;
		try{
			raf = new RandomAccessFile(args[0], "rws");

			//t@Cǂݍ
			int sav[] = new int[(int)raf.length()];
			for(int i=0; i<sav.length; i++){
				sav[i] = raf.readUnsignedByte();
			}

			//tb^[`FbN
			System.out.print("Save type: ");
			if(new String(sav, 0, 4).equals("ARDS")){
				System.out.println("ARDS");
				foot = 500;
			}
			else{
				System.out.println("ROW");
			}

			//`FbNTC
			sum(raf, 0x000000BC + foot, 0x000009AB + foot, sav);
			sum(raf, 0x000009BC + foot, 0x000012AB + foot, sav);
			sum(raf, 0x000012BC + foot, 0x00001BD3 + foot, sav);

			raf.close();

			System.out.println("End");
		}
		catch(IOException ioe){
			System.err.println("Input/Output Error");
			System.exit(-1);
		}
	}

	/**
	 * `FbNTC
	 *
	 * @param raf t@C
	 * @param start JnAhX
	 * @param end IAhX
	 * @param sav[] f[^
	 * @throws IOException 
	 */
	public static void sum(RandomAccessFile raf, int start, int end, int sav[]) throws IOException{
		int sum = 0;
		for(int i=start; i<=end; i++){
			sum += sav[i];
			sum += sav[++i] << 8;
			sum += sav[++i] << 16;
			sum += sav[++i] << 24;
		}

		raf.seek(start - 4);
		raf.write(0xFF & sum);
		raf.write(0xFF & (sum >> 8));
		raf.write(0xFF & (sum >> 16));
		raf.write(0xFF & (sum >> 24));
	}

}
